/*****************************************************
Project : 
Version : 
Date    : 26.01.2008
Author  : -                               
Company : -                               
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
  

const unsigned char font[]={0x3F,0x6,0x5B,0x4F,0x66,0x6D,0x7D,0x7,0x7F,0x6F};
//_____________________________0,__1,___2,___3,___4,___5,___6,__7,___8,___9

unsigned char d[6];
unsigned char dig=0;


#define ADCMUX_U_SET 2
#define ADCMUX_I_SET 3
#define ADCMUX_U 0
#define ADCMUX_I 1
 
#define ADCSETDIV  1023
#define ADC_U_DIV 1023
#define ADC_I_DIV 1023


#define RDAT 200 //0.005 // =0,05*10 (?) / 100(?)



#define BLOCKTRIGGER 3
 

#define ADC_VREF_TYPE 0x40
//#define ADC_VREF_TYPE 0x00

unsigned int settimei,count;
unsigned char  ur;
unsigned long tmp;
unsigned char iind,uind,j,imax;


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0xFA;   
PORTB &= 0xF8;
	PORTD = font[d[dig-1]];
	if (settimei>1500) if (dig==4) PORTD|=128; 
	if (dig==2) PORTD|=128; 
		        
	if (count>350){
        	//if (dig==2) PORTD|=128; 
        	if (dig==4) PORTD|=128; 

	}
	PORTB |=dig;
	dig++; 
	if (dig==7) dig=1;
	if (++count>700) count=0;
        if (settimei<1500) settimei++; 
        else settimei=65535;

}



// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
        ADMUX=adc_input|ADC_VREF_TYPE;
        ADCSRA|=0x40;
        while ((ADCSRA & 0x10)==0);
        ADCSRA|=0x10;
return ADCW;
}

void init(void)
{
        PORTB=0x00;
        DDRB=0xFF;
        PORTC=0x00;
        DDRC=0x74;
        PORTD=0x00;
        DDRD=0xFF;
        TCCR0=0x04;
        TCNT0=0xFA;
        TIMSK=0x01;
        ACSR=0x80;
        SFIOR=0x00;
        // ADC Clock frequency: 62,500 kHz
        // ADC Voltage Reference: AREF pin
        ADMUX=ADC_VREF_TYPE;
        ADCSRA=0x86;

        // Watchdog Timer initialization
        // Watchdog Timer Prescaler: OSC/2048k
      //  #pragma optsize-
      //          WDTCR=0x1F;
      //          WDTCR=0x0F;
      //  #ifdef _OPTIMIZE_SIZE_
      //  #pragma optsize+
      //  #endif

        // Global enable interrupts
        #asm("sei")

}

// Declare your global variables here
 unsigned char u_read(void)
 {
        tmp=read_adc(ADCMUX_U);
        tmp *=255; 
        tmp /=ADC_U_DIV;
        return (unsigned char) tmp;
 }
unsigned char i_read(void) 
{
        tmp=read_adc(ADCMUX_I);
        tmp *=255;
        tmp /=ADC_I_DIV;
        return (unsigned char) tmp;
}
 
unsigned char iset_read(void) 
{
        tmp=read_adc(ADCMUX_I_SET);
        tmp *=255;
        tmp /=ADCSETDIV;
        return (unsigned char)tmp;
} 

void iindf(unsigned char il)
{
	d[3]= il/100;
	il %=100;
	d[4]= il/10;
	il %=10;
	d[5]=il;

}
void uindf(unsigned char ul)
{
	d[0]= ul/100;
	ul %=100;
	d[1]=  ul/10;
	ul %=10;
	d[2]= ul ; 
}


void main(void)
{
init();  
        PORTB &= ~(1<<BLOCKTRIGGER); 
        delay_ms(50);
        PORTB |= (1<<BLOCKTRIGGER); 
        
        

while (1){                           
      
        iind=iset_read(); 
        while (iind!=imax){ 
               imax=iind;   
               iindf(iind);      
               settimei=0; 
               delay_ms(10);
               iind=iset_read();  
        }
        
        iind=i_read();
        ur=iind/RDAT; 
        uind=u_read(); 
        uind -=ur;
        uindf(uind);
	if (settimei<1500)
	    iindf(imax);
	else
	    iindf(iind); 
	    
       // for (j=1; j<100;j++)
        	delay_ms(10);
   };
}
